<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="120px"
      v-loading="formLoading"
    >
      <el-form-item :label="t('DataCollection.DeviceAttributeType.code')" prop="code">
        <el-input v-model="formData.code" :placeholder="t('DataCollection.DeviceAttributeType.placeholderCode')" :disabled = "formType === 'update'"/>
      </el-form-item>
      <el-form-item :label="t('DataCollection.DeviceAttributeType.name')" prop="name">
        <el-input v-model="formData.name" :placeholder="t('DataCollection.DeviceAttributeType.placeholderName')" />
      </el-form-item>
      <el-form-item :label="t('DataCollection.DeviceAttributeType.sort')" prop="sort">
        <el-input-number v-model="formData.sort" :placeholder="t('DataCollection.DeviceAttributeType.placeholderSort')" :min="0" class="!w-full"/>
      </el-form-item>
      <el-form-item :label="t('DataCollection.DeviceAttributeType.remark')" prop="remark">
        <el-input v-model="formData.remark" :placeholder="t('DataCollection.DeviceAttributeType.placeholderRemark')" type="textarea"/>
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">{{ t('DataCollection.DeviceAttributeType.dialogOk') }}</el-button>
      <el-button @click="dialogVisible = false">{{ t('DataCollection.DeviceAttributeType.dialogCancel') }}</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { DeviceAttributeTypeApi, DeviceAttributeTypeVO } from '@/api/iot/deviceattributetype'

/** 采集点分类 表单 */
defineOptions({ name: 'DeviceAttributeTypeForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  code: undefined,
  name: undefined,
  sort: 0,
  remark: undefined,
})
const formRules = reactive({
  code: [{ required: true, message: t('DataCollection.DeviceAttributeType.validatorCodeRequired'), trigger: 'blur' }],
  name: [{ required: true, message: t('DataCollection.DeviceAttributeType.validatorNameRequired'), trigger: 'blur' }],
  sort: [{ required: true, message: t('DataCollection.DeviceAttributeType.validatorSortRequired'), trigger: 'blur' }],
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await DeviceAttributeTypeApi.getDeviceAttributeType(id)
      ;(formData.value as any).sort = Number((formData.value as any).sort ?? 0)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as DeviceAttributeTypeVO
    data.sort = Number((data as any).sort ?? 0)
    if (formType.value === 'create') {
      await DeviceAttributeTypeApi.createDeviceAttributeType(data)
      message.success(t('common.createSuccess'))
    } else {
      await DeviceAttributeTypeApi.updateDeviceAttributeType(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    code: undefined,
    name: undefined,
    sort: 0,
    remark: undefined,
  }
  formRef.value?.resetFields()
}
</script>
